import { DialogSOP } from '../../libappsop/dialogsop';
import { EditFieldSOP } from '../../libappsop/editfieldsop';

export interface DialogCurrencyFields {
  Name?: string;
  ID?: string;
  Symbol?: string;
}

/**
 * Currency dialog.
 */
export class DialogCurrency extends DialogSOP<DialogCurrencyFields> {
  private readonly _efName = new EditFieldSOP('EditFieldName');
  private readonly _efID = new EditFieldSOP('EditFieldID');
  private readonly _efSymbol = new EditFieldSOP('EditFieldSymbol');

  public constructor() {
    super('DialogCreateEditCurrency');

    // Set UI element mapping to pair the UI name to the UI element for use in DialogSOP to find the UI object to set value or verify value
    // This prevents each new Dialog to duplicate code just to set/verify UI element value
    this._uiMap.set('Name', this._efName);
    this._uiMap.set('ID', this._efID);
    this._uiMap.set('Symbol', this._efSymbol);
  }
}
